//do not include gl.h or glu.h for portability
#include <GL/glut.h> 

//fix for windows redefintion of exit
#ifndef _WIN32  
#include <stdlib.h>
#endif 

#include "objreader.h"

objReader o;  
double gAngle = 0;

void init()
{
  glClearColor(0.0, 0.0, 0.0, 0.0); //setting bg color
  glEnable(GL_DEPTH_TEST);  //required for z-buffer

  //setting projection matrix
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();	    	
  glOrtho(-1.0, 1.0, -1.0, 1.0, 1.0, 5.0);		
}

void onDisplay()
{
  //clear screen
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  //setting camera/model positions
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();	
  gluLookAt(0.0, 0.0, 3.0, 0.0, 0.0, -1.0, 0.0, 1.0, 0.0);		
  glRotatef(gAngle,0.0,1.0,0.0);		
		
  //drawing the model
  glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);	
  glColor3f(1.0, 1.0, 1.0);
  o.displayObj();

  //finished drawing, swap the buffer
  glutSwapBuffers();
}

void onIdle() {	
  gAngle += 0.5;
  glutPostRedisplay();
}

void onKey(unsigned char key, int x, int y) {
  if ((key == 'q') || (key=='Q')) {
    exit(0);
  }
}

int main(int argc, char* argv[])
{
  o.loadObj(argv[1]); //parse obj file
  o.centerObject(); //center model around origin
  o.resizeObject(); //resize model, coordinates scaled to [-1,1]x[-1,1]x[-1x1]
	
  //setup window and callbacks
  glutInit(&argc, argv);
  //RGB color, z-buffer, double drawing buffer
  glutInitDisplayMode (GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE); 
  glutInitWindowPosition(100,100);
  glutInitWindowSize(512,512);
  glutCreateWindow("OpenGL Demo");
  glutDisplayFunc(onDisplay);
  glutIdleFunc(onIdle);
  glutKeyboardFunc(onKey);
  init();

  //start GLUT message loop
  glutMainLoop();
  return 0;
}
